#include <stdlib.h>
#include <stdio.h>
#define THREAD_USE_POSIX
#include "libtsctl.h"

#include "NetCANctl.c"
#include "Net.c"
CAN *Net_CANctlInit(int inst,char *host,int mode){
  int socket = ClientSocketNew(host,7552+inst);
  if (socket < 0) return 0;
  NetCANctl *obj = malloc(sizeof(NetCANctl));
  memset(obj,0,sizeof(*obj));

  return NetCANctlInit(obj,socket);
}

int main(int argc,char *argv[]) {
  // Part 1:
  // start the canctl server
  CANPort ci;

  ThreadInit();
  ci.can = CANInit(0);
  ci.port = 7552;
  ThreadNew("canctl server",0,CANStart,0,&ci,0);

  // Part 2:
  // connect to the canctl server
  CAN *can=0;
  int retries=100;
  while (!can && retries-- > 0) {
    can = Net_CANctlInit(0,"localhost",0);
  }
  if (retries < 0) {
    fprintf(stderr,"error starting canctl server\n");
    return 1;
  }
  // Part 3:
  // set the baud rate and send a CAN frame
  CANMessage msg;
  int n;

  msg.flags = 0;
  msg.id = 0x1234;
  msg.length = 4;
  msg.data[0] = 0x11;
  msg.data[1] = 0x22;
  msg.data[2] = 0x33;
  msg.data[3] = 0x44;

  can->API->BaudSet(can,1000000);
  n = can->API->Tx(can,&msg);
  return 0;
}
