#ifndef __arch_h
#define __arch_h
#include "cpp.h"
#include "Time.h"
#include "Bus.h"
#include "Pin.h"
#include "CAN.h"
#include "DIORaw.h"
#include "DIO.h"
#include "SPI.h"
#include "TWI.h"
#include "AIO.h"
#include "System.h"

enum {
  ClassSystem = 0,
  ClassBus = 1,
  ClassTime = 2,
  ClassPin = 3,
  ClassDIORaw = 4,
  ClassDIO = 5,
  ClassTWI = 6,
  ClassCAN = 7,
  ClassSPI = 8,
  ClassEDIO = 10,
  ClassAIO = 11
};
#define ClassesCount (ClassAIO+1)

#define ARCH_C STRINGIFY(ARCH.c)
#define ARCH_H STRINGIFY(ARCH.h)

typedef struct ArchInfo ArchInfo;

struct ArchInfo {
  char *name;
  ArchInfo *next;
  int Instances[ClassesCount];
  int *CANBusNum;
  void (*ArchInit)();
  System *(*SystemInit)(System *,int inst);
  Bus *(*BusInit)(Bus *,int inst);
  Time *(*TimeInit)(Time *,int inst);
  Pin *(*PinInit)(Pin *,int inst);
  DIORaw *(*DIORawInit)(DIORaw *,int inst);
  DIO *(*DIOInit)(DIO *,int inst);
  TWI *(*TWIInit)(TWI *,int inst);
  CAN *(*CANInit)(CAN *,int inst);
  SPI *(*SPIInit)(SPI *,int inst);
  //EDIO *(*EDIOInit)(EDIO *,int inst);
  AIO *(*AIOInit)(AIO *,int inst);
};

extern ArchInfo *ArchLast, *ArchFirst;

#define TEST(func,ptr,...) test ? ptr : func(ptr,##__VA_ARGS__)

#endif
#ifdef __AggregateDIO_H
DIO *DIOInit0(AggregateDIO *);
#endif
