#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "shell.h"
#include "Thread.h"

char **flags;
int nFlags,flagCombos=0;

char **f2(char **arr,char *arch) {
  int i,j;
  char *str,**archlist,*arch0,*arch1;

  archlist = split(arch,'-');
  arch0 = archlist[0];
  arch1 = join(archlist+1,"-");
  if (arch1[0]) arch1 = strappend("-",arch1);
  for (i=0;i<flagCombos;i++) {
    str = strdup(arch0);
    //str = strappend(str,"_glibc");
      //printf("%s",arch);
    for (j=0;j<nFlags;j++) {
      //if (i & (1<<j)) printf("_%s",flags[j]);
      if (i & (1<<j)) str = strappend(str,strf("_%s",flags[j]));
    }
    str = strappend(str,arch1);
    arr = strarrappend(arr,str);
    //printf("\n");
  }
  return arr;
}

char **f1(char **arr,char *prefix,char *arch) {
  char *subarch = var(arch);
  if (!arr) {
    arr = malloc(sizeof(char *));
    arr[0] = 0;
  }
  arr = f2(arr,strf("%s%s",prefix,arch));
  if (subarch[0]) {
    arr = f1(arr,strf("%s%s-",prefix,arch),subarch);
  }
  return arr;
}

// get the index in the arches array containing the arch name
// for the arch of the specified hostname
int ArchGetFromHostName(char *hostname,char **arches) {
  int n=0,i,l;
  char *str;

  while (!isdigit(*hostname)) hostname++;
  while (isdigit(hostname[n])) n++;
  l = len(arches);
  for (i=0;i<l;i++) {
    str = arches[i];
    while (!isdigit(*str)) str++;
    if (!strncmp(str,hostname,n)) return i;
  }
  return -1;
}

char *cmdprefix = "export CFLAGS=-I/mnt/root/usr/include ; ";
int main(int argc,char *argv[],char **env) {
  char **arches,**allarches=0,*syncdir,**hosts,***archhosts,***archalls;
  char **hostcmds;
  int i,j,k,n,nArches,nAll,nHosts,nBuilds,*nh;
  Thread **th;

  ShellDryRun = 0;
  ShellVerbose = 1;
  for (i=0;env[i];i++) {
    sourceline(strappend("env.",env[i]));
  }
  source("BuildProcess.arch",0);
  source(varsubst("${env.PathToRoot}BuildProcess.user"),"make.");

  // first, get a list of all architectures that we need to build for
  // natively on ARM.  Presently, this is all combinations of architectures 
  // inferred from BuildProcess.arch which are not linux86.
  flags = split(var("FLAGS"),' ');
  nFlags = len(flags);
  if (nFlags) flagCombos = 1;
  for (i=0;i<nFlags;i++) flagCombos <<= 1;

  arches = split(var("ARCHES"),' ');
  nArches = len(arches);
  for (i=0;i<nArches;i++) {
    if (strcmp(arches[i],"linux86")) {
      allarches = f1(allarches,"",arches[i]);
    }
  }
  nAll = len(allarches);

  // now, make sure that we have an intermediate and product directory
  // for each architecture in our (first) sync directory.  We use a
  // primary architecture of "glibc", as all on-board compiles share
  // a common compiler (the compiler on the board, which has no prefix).

  syncdir = split(var(varsubst("make.syncdirs_$env.PROJECT")),' ')[0];
  if (!syncdir || !syncdir[0]) {
    printf("Error: no syncdir defined for %s\n",var("env.PROJECT"));
    return 1;
  }
  chdir(syncdir);
  for (i=0;i<nAll;i++) {
    system1(strf("mkdir -p _%s",allarches[i]));
    system1(strf("mkdir -p product_%s",allarches[i]));
  } 

  hosts = split(var("make.natives"),' ');
  /*
    Divide up the work.

    Each board should only compile for its architecture.
    The host names must encode the architecture as follows:
    The host name must start with zero or more non-numeric characters,
    followed by one or more numeric characters, possibly followed by a
    non-numeric character and any other characters.  The numeric characters
    are taken to be the model number of the board.
    We prepend "ts" to the model number to get the architecture.

    At some point we may have architectures that don't conform to this
    and then we will have to update this program to deal with them.

    Anyway, for each architecture (as defined by arches) we must have a
    list of boards of that architecture, and a sub-list of allarches
    containing all the builds for that architecture.  We can then divide
    up the work by evenly dividing each item in the second sub-list to
    one item in the first sub-list.
   */
  nHosts = len(hosts);
  archhosts = malloc(nArches * sizeof(char *));
  for (i=0;i<nArches;i++) {
    archhosts[i] = 0;
  }
  for (i=0;i<nHosts;i++) {
    j = ArchGetFromHostName(hosts[i],arches);
    if (j < 0) {
      printf("Warning: No arch for host %s\n",hosts[i]);
      continue;
    }
    archhosts[j] = strarrappend(archhosts[j],hosts[i]);
  }
  // associate each full architecture with the primary arch
  // sure, we could have done this already (and more easily)
  // when we first constructed the full arch, but since we didn't
  // we will do it here
  archalls = malloc(nArches * sizeof(char *));
  for (i=0;i<nArches;i++) {
    archalls[i] = 0;
  }
  for (i=0;i<nAll;i++) {
    for (j=0;j<nArches;j++) {
      if (!strncmp(allarches[i],arches[j],strlen(arches[j]))) {
	archalls[j] = strarrappend(archalls[j],allarches[i]);
	break;
      }
    }
  }

  for (i=0;i<nArches;i++) {
    nBuilds = len(archalls[i]);
    printf("Arches for %s:%d\n",arches[i],nBuilds);
    for (j=0;j<nBuilds;j++) {
      printf("\t%s\n",archalls[i][j]);
    }
    n = len(archhosts[i]);
    printf("Hosts for %s:%d\n",arches[i],n);
    for (j=0;j<n;j++) {
      printf("\t%s\n",archhosts[i][j]);
    }
  }

  nh = malloc(sizeof(int) * nArches);
  for (i=0;i<nArches;i++) {
    nh[i] = len(archhosts[i]);
  }
  /*
    Construct a list of commands for each host.
    TO DO: don't hardcode what we are building!
   */
  hostcmds = malloc(sizeof(char *)*nHosts);
  for (i=0;i<nHosts;i++) {
    hostcmds[i] = strdup(cmdprefix);
  }
  for (i=0;i<nArches;i++) {
    nBuilds = len(archalls[i]);
    if (nh[i] == 0 && nBuilds) {
      printf("No hosts available to build %s\n",arches[i]);
      return 1;
    }
    n = 0;
    for (j=0;j<nBuilds;j++) {
      k = strlookup(hosts,archhosts[i][n]);
      hostcmds[k] = strappend(hostcmds[k],
		 strf("only=%s make product_%s/libtsctl.a && ",
		      archalls[i][j],archalls[i][j]));
      if (++n >= nh[i]) n = 0;
    }
  }

  void *func(void *th) {
    Thread *me = th;

    // TO DO: prepend all output of command with 
    // "[%s]:",me->name
    return (void *)system1((char *)me->data);
  }

  ThreadInit();
  th = malloc(sizeof (Thread *) * nHosts);
  void *ret;

  for (i=0;i<nHosts;i++) {
    hostcmds[i] = strappend(hostcmds[i],"true");
    th[i] = ThreadNew(hosts[i],-1-i,func,0,
		      strf("ssh root@%s \"%s\" 2>&1 | while read line; do echo \"[%s] $line\"; done\n",hosts[i],hostcmds[i],hosts[i]), 0);
  }

  for (i=0;i<nHosts;i++) {
    pthread_join(th[i]->tid,&ret);
    if (ret) {
      printf("error on %s\n",hosts[i]);
      exit(1);
    }
  }
}

//gcc -DTHREAD_USE_POSIX -o native/make-glibc make-glibc.c HashTable.c shell.c PThread.c IPC.c -lpthread                                                       
