//#include "MarvellPXA166TWI.c"
#include "Thread.c"
#include "ts4700.h"
#include "MMapBus.c"
#include "SystemTime.c"
#include "AggregateDIO.c"
#include "DIOTWI.c"
#include "PhysicalDIO.c"
#include "ts4700Pin.c"
#include "ts4700DIORaw.c"
#include "TSMuxBus.c"
#include "MarvellPXA166DIORaw.c"
#include "CacheBus.c"
#include "SJA1000CAN.c"
#include "LocalSystem.c"
#include "WBSPI.c"
#include "baudtab.h"
#include "arch.h"

int ModelId=0x4700;
const char *ts4700_archname = "ts4700";

// object hierarchy
MMapBus MarvellPXA166DIOBus, ts4700DIOBus, ts4700CANBus, testbus, twiregs,
  mfpregs, mux8bus, mux16bus, spi8bus, spi16bus;
TSMuxBus muxbus;
CacheBus MarvellPXA166DIOCacheBus, ts4700DIOCacheBus;
MarvellPXA166DIORaw MarvellPXA166DIORaw0;
ts4700DIORaw ts4700DIORaw0;
PhysicalDIO MarvellPXA166DIO, ts4700DIO;
AggregateDIO DIO0;
SystemTime Time0;
//MarvellPXA166TWI TWI0;
DIOTWI TWI0;
SJA1000CAN CAN0;
ts4700Pin ts4700Pin0;
WBSPI SPI0;
System sys;

CANConn CAN0conn[16];

#define ts4700DIOCacheBusLength 12
unsigned ts4700DIOCacheBus_WO[ts4700DIOCacheBusLength];
unsigned ts4700DIOCacheBus_IBit[ts4700DIOCacheBusLength];
unsigned ts4700DIOCacheBus_OBit[ts4700DIOCacheBusLength];
unsigned ts4700DIOCacheBus_icache[ts4700DIOCacheBusLength];
unsigned ts4700DIOCacheBus_ocache[ts4700DIOCacheBusLength];
unsigned ts4700DIOCacheBus_ocache0[ts4700DIOCacheBusLength];

#define MarvellPXA166DIOCacheBusLength 0x4A
unsigned MarvellPXA166DIOCacheBus_WO[MarvellPXA166DIOCacheBusLength];
unsigned MarvellPXA166DIOCacheBus_IBit[MarvellPXA166DIOCacheBusLength];
unsigned MarvellPXA166DIOCacheBus_OBit[MarvellPXA166DIOCacheBusLength];
unsigned MarvellPXA166DIOCacheBus_icache[MarvellPXA166DIOCacheBusLength];
unsigned MarvellPXA166DIOCacheBus_ocache[MarvellPXA166DIOCacheBusLength];
unsigned MarvellPXA166DIOCacheBus_ocache0[MarvellPXA166DIOCacheBusLength];

unsigned char MarvellPXA166DIOCapabilities[128];
unsigned char ts4700DIOCapabilities[62];

char testbusdata[4096];

void ts4700_ArchInit() {
  ThreadInit();
}

System *ts4700__SystemInit0(System *s,int inst) {
  return LocalSystemInit(&sys);
}
#define ts4700SystemInstances 1

Bus *ts4700__BusInit0(Bus *bus,int inst) {
  return MMapBusInit(&ts4700DIOBus,0x80004000,1);
}
Bus *ts4700__BusInit1(Bus *bus,int inst) {
  return MMapBusInit2(&testbus,testbusdata,1);
}
Bus *ts4700__BusInit2(Bus *bus,int inst) {
  return TSMuxBusInit(&muxbus,BusInit(0),0x4,BusInit(9),0,BusInit(10),0);
}
Bus *ts4700__BusInit3(Bus *bus,int inst) {
  return MMapBusInit(&MarvellPXA166DIOBus,0xD4019000,1);
}
Bus *ts4700__BusInit4(Bus *bus,int inst) {
  return MMapBusInit(&ts4700CANBus,0x81004c00,1);
}
Bus *ts4700__BusInit5(Bus *bus,int inst) {
  ts4700DIOCacheBus_IBit[8] = 0x7FFF;
  ts4700DIOCacheBus_IBit[9] = 0x7FF;
  ts4700DIOCacheBus_IBit[10] = 0xFFFF;
  ts4700DIOCacheBus_IBit[11] = 0xFFF;
  ts4700DIOCacheBus_OBit[0] = 0x7FFF;
  ts4700DIOCacheBus_OBit[1] = 0x1FFF;
  ts4700DIOCacheBus_OBit[2] = 0xFFFF;
  ts4700DIOCacheBus_OBit[3] = 0xFFF;
  ts4700DIOCacheBus_OBit[4] = 0x7FFF;
  ts4700DIOCacheBus_OBit[5] = 0x7FF;
  ts4700DIOCacheBus_OBit[6] = 0xFFFF;
  ts4700DIOCacheBus_OBit[7] = 0xFFF;

  ts4700DIOCacheBus.Length=ts4700DIOCacheBusLength;
  ts4700DIOCacheBus.Width=16;
  ts4700DIOCacheBus.Offset=0x10;
  ts4700DIOCacheBus.WO=ts4700DIOCacheBus_WO;
  ts4700DIOCacheBus.IBit=ts4700DIOCacheBus_IBit;
  ts4700DIOCacheBus.OBit=ts4700DIOCacheBus_OBit;
  ts4700DIOCacheBus.icache=ts4700DIOCacheBus_icache;
  ts4700DIOCacheBus.ocache=ts4700DIOCacheBus_ocache;
  ts4700DIOCacheBus.ocache0=ts4700DIOCacheBus_ocache0;
  return CacheBusInit(&ts4700DIOCacheBus,BusInit(0));
}
Bus *ts4700__BusInit6(Bus *bus,int inst) {
  MarvellPXA166DIOCacheBus_IBit[0] = 0xFFFFFFFF;
  MarvellPXA166DIOCacheBus_IBit[1] = 0xFFFFFFFF;
  MarvellPXA166DIOCacheBus_IBit[2] = 0xFFFFFFFF;
  MarvellPXA166DIOCacheBus_IBit[64] = 0xFFFFFFFF;
  MarvellPXA166DIOCacheBus_OBit[3] = 0xFFFFFFFF;
  MarvellPXA166DIOCacheBus_OBit[4] = 0xFFFFFFFF;
  MarvellPXA166DIOCacheBus_OBit[5] = 0xFFFFFFFF;
  MarvellPXA166DIOCacheBus_OBit[67] = 0xFFFFFFFF;
  MarvellPXA166DIOCacheBus_WO[6] = 0xFFFFFFFF;
  MarvellPXA166DIOCacheBus_WO[7] = 0xFFFFFFFF;
  MarvellPXA166DIOCacheBus_WO[8] = 0xFFFFFFFF;
  MarvellPXA166DIOCacheBus_WO[70] = 0xFFFFFFFF;
  MarvellPXA166DIOCacheBus_WO[9] = 0xFFFFFFFF;
  MarvellPXA166DIOCacheBus_WO[10] = 0xFFFFFFFF;
  MarvellPXA166DIOCacheBus_WO[11] = 0xFFFFFFFF;
  MarvellPXA166DIOCacheBus_WO[73] = 0xFFFFFFFF;
  
  MarvellPXA166DIOCacheBus.Length=MarvellPXA166DIOCacheBusLength;
  MarvellPXA166DIOCacheBus.Width=32;
  MarvellPXA166DIOCacheBus.Offset=0;
  MarvellPXA166DIOCacheBus.WO=MarvellPXA166DIOCacheBus_WO;
  MarvellPXA166DIOCacheBus.IBit=MarvellPXA166DIOCacheBus_IBit;
  MarvellPXA166DIOCacheBus.OBit=MarvellPXA166DIOCacheBus_OBit;
  MarvellPXA166DIOCacheBus.icache=MarvellPXA166DIOCacheBus_icache;
  MarvellPXA166DIOCacheBus.ocache=MarvellPXA166DIOCacheBus_ocache;
  MarvellPXA166DIOCacheBus.ocache0=MarvellPXA166DIOCacheBus_ocache0;
  
  return CacheBusInit(&MarvellPXA166DIOCacheBus,BusInit(3));
}
Bus *ts4700__BusInit7(Bus *bus,int inst) { // CPU TWI regs
  return MMapBusInit(&twiregs,0xD4025008,1); // 0xD4011008
}
Bus *ts4700__BusInit8(Bus *bus,int inst) { // CPU MFP regs
  return MMapBusInit(&mfpregs,0xD401E000,1); // 0xD4011008
}
Bus *ts4700__BusInit9(Bus *bus,int inst) {
  return MMapBusInit(&mux8bus,0x81008000,8);
}
Bus *ts4700__BusInit10(Bus *bus,int inst) {
  return MMapBusInit(&mux16bus,0x80008000,8);
}
Bus *ts4700__BusInit11(Bus *bus,int inst) {
  return MMapBusInit(&spi8bus,0x81004800,1);
}
Bus *ts4700__BusInit12(Bus *bus,int inst) {
  return MMapBusInit(&spi16bus,0x80004800,1);
}
#define ts4700BusInstances 13

Time *ts4700__TimeInit0(Time *t,int inst) {
  return SystemTimeInit(&Time0);
}
#define ts4700TimeInstances 1

Pin *ts4700__PinInit0(Pin *pin,int inst) {
  return ts4700PinInit(&ts4700Pin0,BusInit(0),BusInit(8));
}
#define ts4700PinInstances 1

DIORaw *ts4700__DIORawInit0(DIORaw *dioraw,int inst) {
  return ts4700DIORawInit(&ts4700DIORaw0,BusInit(5));
}
DIORaw *ts4700__DIORawInit1(DIORaw *dioraw,int inst) {
  return MarvellPXA166DIORawInit(&MarvellPXA166DIORaw0,BusInit(6));
}
#define ts4700DIORawInstances 2

DIO *ts4700__DIOInit0(DIO *dio,int inst) {
  return DIOInit0((void *)&DIO0);
}
DIO *ts4700__DIOInit1(DIO *dio,int inst) {
  int i,n;
  DIORaw *raw = DIORawInit(0);

  if (raw) {
    n = raw->API->Count(raw);
    ts4700DIO.Capabilities = ts4700DIOCapabilities;
    for (i=0;i<n;i++) {
      ts4700DIOCapabilities[i] = DIO_NORMAL;
    }
  }
  return PhysicalDIOInit(&ts4700DIO,BusInit(5),raw);
}
DIO *ts4700__DIOInit2(DIO *dio,int inst) {
  int i,n;
  DIORaw *raw = DIORawInit(1);

  if (raw) {
    n = raw->API->Count(raw);
    MarvellPXA166DIO.Capabilities = MarvellPXA166DIOCapabilities;
    for (i=0;i<n;i++) {
      MarvellPXA166DIOCapabilities[i] = DIO_NORMAL;
    }
  }
  return PhysicalDIOInit(&MarvellPXA166DIO,BusInit(6),raw);
}
#define ts4700DIOInstances 3

TWI *ts4700__TWIInit0(TWI *twi,int inst) {
  TWI0.TW_CLK=150;
  TWI0.TW_DAT=149;
  TWI0.Speed=1000000;
  TWI0.LockNum=1;
  return DIOTWIInit(&TWI0,DIOInit(0),TimeInit(0));
}
#define ts4700TWIInstances 1

int CANBusNum[1] = { 4 };

CAN *ts4700__CANInit0(CAN *can,int inst) {
  CAN0.LockNum = 2;
  CAN0.status = 0;
  CAN0.CAN_TX = 15;
  CAN0.CAN_RX = 16;
  CAN0.D.conn = CAN0conn;
  CAN0.D.maxconn = 16;
  CAN0.D.nconn = 0;
  CAN0.D.txc = 0;
  CAN0.baud = 1000000;
  CAN0.baudparms = baudparms25;
  CAN0.irq = 65;
  return SJA1000CANInit(&CAN0,BusInit(4),PinInit(0),TimeInit(0));
}
#define ts4700CANInstances 1

static void ts4700SPIChipSelect(WBSPI *ob,unsigned num,int asserted) {
  if (num > 0) return; // CS1-3# not available
  if (!asserted) return; // core will do this automatically
  ob->bus->API->Lock(ob->bus,0,0);
  ob->bus->API->Poke16(ob->bus,ob->offset,
		  (ob->bus->API->Peek16(ob->bus,ob->offset) & 0xFC7F)
		  | (num << 8) | (1 << 7));
  ob->bus->API->Unlock(ob->bus,0,0);
  return;
}

SPI *ts4700__SPIInit0(SPI *spi,int inst) {
  SPI0.LockNum = 7; // ???
  return WBSPIInit(&SPI0,BusInit(12),BusInit(11),0,ts4700SPIChipSelect);
}
#define ts4700SPIInstances 1

//#define ts4700EDIOInstances

#define ts4700AIOInstances 0

#define ARCH ts4700
#define CLASS_INC "classinit2.h"
#include "classeach.h"

#include "archinit.h"
#define ARCH_LAST ts4700

// Author: Michael Schmidt (michael@embeddedARM.com)
// Copyright (c) 2012, Technologic Systems, All Rights Reserved
// Refer to the COPYRIGHT file provided with this project for licensing terms.
